<?php

class ControllerExtensionPaymentPaybylink extends Controller {
    private $error = array();
    private $data = array();

    public function index() {
        $this->load->language('extension/payment/paybylink');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('payment_paybylink', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');
        }

        if (isset($this->error['secret'])) {
            $data['error_secret'] = $this->error['secret'];
        } else {
            $data['error_secret'] = '';
        }

        if (isset($this->error['pp'])) {
            $data['error_pp'] = $this->error['pp'];
        } else {
            $data['error_pp'] = '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'])
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment')
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/payment/paybylink', 'user_token=' . $this->session->data['user_token'])
        );

        $data['action'] = $this->url->link('extension/payment/paybylink', 'user_token=' . $this->session->data['user_token']);

        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment');

        if (isset($this->request->post['payment_paybylink_title'])) {
            $data['payment_paybylink_title'] = $this->request->post['payment_paybylink_title'];
        } else {
            $data['payment_paybylink_title'] = $this->config->get('payment_paybylink_title');
        }

        if (isset($this->request->post['payment_paybylink_shopid'])) {
            $data['payment_paybylink_shopid'] = $this->request->post['payment_paybylink_shopid'];
        } else {
            $data['payment_paybylink_shopid'] = $this->config->get('payment_paybylink_shopid');
        }

        if (isset($this->request->post['payment_paybylink_hash'])) {
            $data['payment_paybylink_hash'] = $this->request->post['payment_paybylink_hash'];
        } else {
            $data['payment_paybylink_hash'] = $this->config->get('payment_paybylink_hash');
        }

        if (isset($this->request->post['payment_paybylink_order_status_id'])) {
            $data['payment_paybylink_order_status_id'] = $this->request->post['payment_paybylink_order_status_id'];
        } else {
            $data['payment_paybylink_order_status_id'] = $this->config->get('payment_paybylink_order_status_id');
        }

        if (isset($this->request->post['payment_paybylink_order_status_new_id'])) {
            $data['payment_paybylink_order_status_new_id'] = $this->request->post['payment_paybylink_order_status_new_id'];
        } else {
            $data['payment_paybylink_order_status_new_id'] = $this->config->get('payment_paybylink_order_status_new_id');
        }

        if (isset($this->request->post['payment_paybylink_order_status_cancel_id'])) {
            $data['payment_paybylink_order_status_cancel_id'] = $this->request->post['payment_paybylink_order_status_cancel_id'];
        } else {
            $data['payment_paybylink_order_status_cancel_id'] = $this->config->get('payment_paybylink_order_status_cancel_id');
        }

        $this->load->model('localisation/order_status');

        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        if (isset($this->request->post['payment_paybylink_status'])) {
            $data['payment_paybylink_status'] = $this->request->post['payment_paybylink_status'];
        } else {
            $data['payment_paybylink_status'] = $this->config->get('payment_paybylink_status');
        }

        if (isset($this->request->post['payment_paybylink_sort_order'])) {
            $data['payment_paybylink_sort_order'] = $this->request->post['payment_paybylink_sort_order'];
        } else {
            $data['payment_paybylink_sort_order'] = $this->config->get('payment_paybylink_sort_order');
        }

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/paybylink', $data));
    }

    private function validate() {
        if (!$this->user->hasPermission('modify', 'extension/payment/paybylink')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (!$this->request->post['payment_paybylink_shopid']) {
            $this->error['shopid'] = $this->language->get('error_shopid');
        }

        if (!$this->request->post['payment_paybylink_hash']) {
            $this->error['hash'] = $this->language->get('error_paybylink');
        }

        return !$this->error;
    }
}